<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Modelo de Revisión en Sitio</strong>
    </div>
    <div v-if="isDirector.value">
      <!--<router-link tag="li" to="/hello">
        <strong>
          <u>
            <small>¿No es el Gerente que buscabas? Regresa al buscador</small>
          </u>
        </strong>
      </router-link>-->
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong v-if="!isDirector.value">Bienvenido a Certificación de Calidad</strong>
        <strong v-else>Detalles de desempeño del Gerente: {{this.gerente.nombre}} y el equipo a su cargo</strong>
      </div>

      <div>
        <span>Información con corte al {{this.dia}} de {{this.mes}} {{this.anio}}</span>
      </div>
    </div>

    <div class="contenedorPrincipal">
      <v-row>
        <v-col :cols="12" :md="5" class="pl-8">
          <div class="titSec">Cobertura Trimestral de Certificación</div>
          <div class="gris">
            <CoberturaOdometro :filtros = this.filtrosOdometro />
          </div>
        </v-col>
        <v-col :cols="12" :md="7" class="pr-8">
          <div class="titSec">
            <span>Comparativa de cobertura: Semana actual vs Semanas anteriores</span>
            <v-btn @click="visualizarPopUp = true"
              >Descargar Reporte Territorio</v-btn>
          </div>
          <div class="gris">
            <CoberturaComparativa :filtros = this.filtrosBarras />
          </div>
        </v-col>
      </v-row>
      <div class="gris">
        <TablaPuntosVenta :filtros="this.filtrosOdometro" />
      </div>
    </div>

    <v-dialog v-model="visualizarPopUp" max-width="800px">
      <v-card>
        <v-toolbar dense color="grey">
          <v-spacer></v-spacer>
          <v-btn icon color="white" @click="visualizarPopUp = false">
            <v-icon>mdi-close</v-icon>
          </v-btn>
        </v-toolbar>
        <DescargaExcelPopUp :idNegocio="this.negocio.idNegocio" :idGerente="this.gerente.id_gerente" />
      </v-card>
    </v-dialog>

  </div>
</template>
<style scoped>
</style>

<script>
import FileSaver from "file-saver";
import CoberturaOdometro from "@/views/secure/certificacion-calidad/components/CoberturaOdometro001_004.vue";
import TablaPuntosVenta from "@/views/secure/certificacion-calidad/components/TablaPuntosVenta006_007.vue";
import CoberturaComparativa from "@/views/secure/certificacion-calidad/components/CoberturaComparativa002_005.vue";
import DescargaExcelPopUp from "@/views/secure/certificacion-calidad/components/DescargaExcelPopUp.vue";
import store from "@/store";
import axios from "axios";
import router from "@/router";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
export default {
  components: {
    CoberturaOdometro,
    TablaPuntosVenta,
    CoberturaComparativa,
    DescargaExcelPopUp
  },
  data() {
    return {
      gerente: {},
      negocio: null,
      visualizarPopUp : false,
      filtrosFechas:{},
      filtrosOdometro:{},
      filtrosBarras:{},
      months: [
        "Enero",
        "Febrero",
        "Marzo",
        "Abril",
        "Mayo",
        "Junio",
        "Julio",
        "Agosto",
        "Septiembre",
        "Octubre",
        "Noviembre",
        "Diciembre",
      ], // Store month names in array
      dia: 0,
      mes: "",
      anio: 0,
      isDirector: {},
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Modelo de Revisión en Sitio",
          disabled: false,
          exact: true,
          to: {
            name: "certificacion_calidad_director",
          },
        },
        {
          text: "Dashboard",
          disabled: true,
        },
      ],
    };
  },
  methods: {
      getReport(){
 const self = this;
  
      let url =
        "/franquicia/dashboard/reportes/secure/cobertura/?" +
        "fechaInicial=" +
        this.filtrosFechas.fechaInicio +
        "&fechaFinal=" +
        this.filtrosFechas.fechaFin +
        "&idNegocio=" +
        this.negocio.idNegocio + 
        "&idGerente=" + this.gerente.id_gerente;

      let axiosConfig = {
        headers: {
          "content-type": "application/x-www-form-urlencoded;charset=utf-8",
        },
      };

      axios
        .get(url, {
          headers: {
            "Content-Type": "application/json;charset=UTF-8",
          },
          data: {}, // envío un cuerpo (aunque sea un objeto vacío)
        })
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
            
              if (data) { 
                 this.exportToExcel(data);
                 
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });

    },

    exportToExcel(data) {
      const dataFinal = {data};
      //dataFinal[data] = data;
      axios({
        method: "post",
        url: "/json/convert/secure/array/excel",
        responseType: "blob",
        data: dataFinal
      })
        .then((response) => {
          if (response.headers["content-type"] !== "application/json") {
            FileSaver.saveAs(response.data, response.headers["file-name"]);
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    getDateYesterday() {
      var date = new Date();
      date.setDate(date.getDate() - 1);
      this.dia = date.getDate();
      this.mes = this.months[date.getMonth()];
      this.anio = date.getFullYear();
    },
    formatDate(date) {
      var d = new Date(date),
        month = "" + (d.getMonth() + 1),
        day = "" + d.getDate(),
        year = d.getFullYear();

      if (month.length < 2) month = "0" + month;
      if (day.length < 2) day = "0" + day;

      return [day, month, year].join("/");
    },
    initFiltrosOdometro(){
      this.filtrosOdometro.fechaInicio = this.filtrosFechas.fechaInicio;
      this.filtrosOdometro.fechaFin = this.filtrosFechas.fechaFin;
      this.filtrosOdometro.idNegocio = this.negocio.idNegocio;
      this.filtrosOdometro.idGerente = this.gerente.id_gerente;
    },
    initFiltrosBarras(){
      var date = new Date();
      this.filtrosBarras.semanasAtras = 7;
      this.filtrosBarras.fechaActual = this.formatDate(date);
      this.filtrosBarras.idNegocio = this.negocio.idNegocio;
      this.filtrosBarras.idGerente = this.gerente.id_gerente;
    }
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
  },
  mounted() {
    this.getDateYesterday();
  },
  created() {
    if (this.$route.params.negocio) {
      this.negocio = this.serviceCommons.base64ToObject(
        this.$route.params.negocio
      );
      this.filtrosFechas = this.serviceCommons.base64ToObject(
        this.$route.params.filtrosFechas
      );

      this.isDirector = this.serviceCommons.base64ToObject(
        this.$route.params.isDirector
      );

      this.gerente = this.serviceCommons.base64ToObject(
        this.$route.params.gerente
      );
      
      this.initFiltrosOdometro();
      this.initFiltrosBarras();
    }
  },
};
</script>
